#include "monopoly2.h"
#include<iostream>
#include<algorithm>
#include<vector>
using namespace std;
const int MAXN=1000;
int n;
int parent[MAXN+1];
int inds[MAXN+1];
vector <bool> find_check (vector <int> p) {
    for (int i=0; i<n; i++) {
        inds[p[i]]=i;
    }
    vector <bool> result(n);
    result[inds[0]]=false;
    for (int i=2; i<=n; i++) {
        int p=parent[i];
        if ((inds[p]>inds[i])||(result[inds[p]]==true)) result[inds[i]]=true;
    }
    return result;
}
bool generate_tree (int curr) {
    if (curr==n+1) {
        vector <int> perm(n);
        for (int i=0; i<n; i++) {
            perm[i]=i+1;
        }
        bool flag=true;
        for (;;) {
            if (check(perm)!=find_check(perm)) {
                flag=false;
                break;
            }
            if (next_permutation(perm.begin(),perm.end())==false) break;
        }
        return flag;
    }
    for (int i=1; i<curr; i++) {
        parent[curr]=i;
        if (generate_tree(curr+1)==true) return true;
    }
    return false;
}
vector <pair <int, int> > find_connections (int n) {
    ::n=n;
    generate_tree(2);
    vector <pair <int, int> > ans;
    ans.reserve(n-1);
    for (int i=2; i<=n; i++) {
        ans.push_back({parent[i], i});
    }
    return ans;
}
