#include "monopoly2.h"
#include<iostream>
#include<vector>
#include<set>
using namespace std;

//#include "Lgrader.cpp"

int _n;
vector<pair<int, int>> edges;

set<int> get_subtree(int i, int j)
{
    vector<int> q;
    int idx_i = 0;
    for (int k = 1; k <= _n; ++ k)
    {
        if (k == i) 
        {
            q.push_back(j);
            idx_i = q.size() - 1;
            q.push_back(i);
        }
        else if (k != j) q.push_back(k);
    }
    auto res = check(q);
    set<int> subtree;
    for (int idx = 0; idx < res.size(); ++ idx)
    {
        if (res[idx]) subtree.insert(q[idx]);
    }
    return subtree;
}

void DFS(set<int> &subtree)
{
    int u = *subtree.begin();
    subtree.erase(u);

    while (!subtree.empty())
    {
        int v = *subtree.begin();
        auto v_st = get_subtree(u, v);
        edges.push_back({u, v});
        for (int w : v_st)
        {
            subtree.erase(w);
        }
        DFS(v_st);
    }
}

vector <pair <int, int> > find_connections (int N) {
    _n = N;
    
    set<int> tree;
    for (int i = 1; i <= _n; ++ i)
    {
        tree.insert(i);
    }
    
    DFS(tree);

    return edges;
}

